<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;

class TransferioModel extends BaseModel
{
	/**
	 * table name from database
	 */
	protected $table = "pindahbarangio";

	/**
	 *   alias table for relation issues
	 */
	protected $aliasTable = "transferio";

	/**
	 * primary key from table remember eloquent doesnt support composite primary key
	 */
	protected $primaryKey = "id";
	/**
	 * check the incrementing boolean if the incrementing from database is false then the value is false by default
	 */
	// public $incrementing = false;
	/**
	 * fillable property for eloquent attribute cast
	 */
	protected $fillable = [
		"id", "ioNumber", "type", "requesterId", "approverId", "fromKapalId", "jlhBarang", "toKapalId", "fromLocationId", "toLocationId", "toOrganization", "expectedReceivedDate", "status",
		"feedback", "voyageKode", "voyageStart", "voyageEnd", "komentar", "date_updated", "tglApproved"
	];
	/**
	 * Creating raw object from table that, this purpose for making you easier for remembering all attribute
	 */


	/**
	 * paging for default paging purpose
	 * if you want to add new paging property you have to add the property in this array
	 * you have to add the relation value
	 * remember this is not suported casting value you have to handle by your self
	 */
	protected $aliasPaging = [
		"id" => "transferio.id",
		"ioNumber" => "transferio.ioNumber",
		"toOrganization" => "transferio.toOrganization",
		"toKapalId" => "transferio.toKapalId",

		"toNamaKapal" => "toKapalId.namaKapal",

		"expectedReceivedDate" => "transferio.expectedReceivedDate",
		"status" => "transferio.status",
		"voyageKode" => "transferio.voyageKode",
		"voyageStart" => "transferio.voyageStart",
		"voyageEnd" => "transferio.voyageEnd"
	];

	/**
	 * relation from ' . kapal . ' by ' . fromKapalId 
	 * join kapal on kapal.id = transferio.fromKapalId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationFromKapalId($alias = "fromKapalId")
	{
		$this->getQuery()->join("kapal as $alias", "$alias.id", "=", "transferio.fromKapalId");
		return $this;
	}
	/**
	 * relation from ' . kapal . ' by ' . toKapalId 
	 * join kapal on kapal.id = transferio.toKapalId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationToKapalId($alias = "toKapalId")
	{
		$this->getQuery()->leftjoin("kapal as $alias", "$alias.id", "=", "transferio.toKapalId");
		return $this;
	}
	/**
	 * relation from ' . lokasiitem . ' by ' . fromLocationId 
	 * join lokasiitem on lokasiitem.id = transferio.fromLocationId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationFromLocationId($alias = "fromLocationId")
	{
		$this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "transferio.fromLocationId");
		return $this;
	}
	/**
	 * relation from ' . lokasiitem . ' by ' . toLocationId 
	 * join lokasiitem on lokasiitem.id = transferio.toLocationId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationToLocationId($alias = "toLocationId")
	{
		$this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "transferio.toLocationId");
		return $this;
	}
	/**
	 * relation from ' . users . ' by ' . approverId 
	 * join users on users.id = transferio.approverId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationApproverId($alias = "approverId")
	{
		$this->getQuery()->join("users as $alias", "$alias.id", "=", "transferio.approverId");
		return $this;
	}
	/**
	 * relation from ' . users . ' by ' . requesterId 
	 * join users on users.id = transferio.requesterId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationRequesterId($alias = "requesterId")
	{
		$this->getQuery()->join("users as $alias", "$alias.id", "=", "transferio.requesterId");
		return $this;
	}
	/**
	 * relation from ' . itemtransferio . ' by ' . penyesuaianBarangId 
	 * join itemtransferio on itemtransferio.id = transferio.penyesuaianBarangId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationItemtransferioPenyesuaianBarangId($alias = "itemtransferio")
	{
		$this->getQuery()->join("itemtransferio as $alias", "$alias.penyesuaianBarangId", "=", "transferio.id");
		return $this;
	}

	public function joinRelationVoyageKode($alias = "voyageKode")
	{
		$this->getQuery()->leftjoin("voyages as $alias", function ($join) use ($alias) {
			$join->on("$alias.voyageKode", "=", "transferio.voyageKode");
			$join->on("$alias.kapalId", "=", "transferio.fromKapalId");
		});
		return $this;
	}
}
